﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Windows.Media.Imaging;
using Telerik.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using System.Windows.Data;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls.TreeView;

namespace silverlightDragNDrop
{
	public partial class MainPage : UserControl
	{
		private ObservableCollection<Employee> _employee = new ObservableCollection<Employee>();
		private ObservableCollection<object> folders = new ObservableCollection<object>();

		int tempid = 0;
		public MainPage()
		{
			InitializeComponent();


			LoadEmployee();
			LoadTreeFolders();

			RadDragAndDropManager.AddDragQueryHandler(GridView1, OnDragQuery);
			RadDragAndDropManager.AddDragInfoHandler(GridView1, OnDragInfo);

			// Note that the tree view handles the drag drop events when the IsDragDropEnabled property is set to true,
			// this is why we use this override to sign up.
			Tree.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery), true);

			// The same applies for the DragInfo event as well. It can be used to add custom actions when a drop is
			// successful. By default the TreeView will add items to the ItemsSource collection.
			//Tree.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo), true);
			
			GridView1.ItemsSource = _employee;

		}


		private void OnDropInfo(object sender, DragDropEventArgs e)
		{
			return;
			int folderId;
			var destinationItem = e.Options.Destination as Control;
			var employees = e.Options.Payload as IList<Employee>;

			if (employees == null && e.Options.Payload is Employee)
			{
				employees = new List<Employee>() { e.Options.Payload as Employee };
			}

			if (e.Options.Status == DragStatus.DropComplete)
			{
				if (destinationItem != null && employees != null)
				{
					//var treeViewItem = destinationItem as RadTreeViewItem;
					//var employees = e.Options.Payload as IList<Employee>;
					foreach (var employee in employees)
					{
						//Write the code to assign folder

						if (destinationItem.ToString() == "Inbox")
						{
							tempid = 1;
							employee.id = tempid;
						}
					}

					e.Handled = true;

				}
			}
		}

		private void OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			var destinationItem = e.Options.Destination as RadTreeViewItem;
			var sourceItem = e.Options.Source as Control;

			var employee = e.Options.Payload as IList<Employee>;

			if (e.Options.Status == DragStatus.DropDestinationQuery)
			{
				if (destinationItem != sourceItem)
				{
					e.QueryResult = true;
					e.Handled = true;
				}
				else
				{
					e.QueryResult = false;
				}

				var folder = destinationItem.Item as TreeViewFolder;
				if (folder == null)
				{
					e.QueryResult = false;
					return;
				}

				// We only want to drop employees inside a folder and only
				// under certain conditions
				e.QueryResult = folder.CanCotnainEmployees && destinationItem.DropPosition == DropPosition.Inside;


				//if (destinationItem.FullPath == CurrentLanguage.Email.LBLPERSONALFOLDERS)
				//{
				//    e.QueryResult = false;
				//}
			}


		}

		private void OnDragInfo(object sender, DragDropEventArgs e)
		{
			//throw new NotImplementedException();
		}

		private void OnDragQuery(object sender, DragDropQueryEventArgs e)
		{
			if (e.Options.Status == DragStatus.DragQuery)
			{
				e.QueryResult = true;

				var dataGrid = sender as RadGridView;
				var items = GridView1.SelectedItems.Cast<Employee>().ToList();

				e.Options.Payload = items;
				e.Options.ArrowCue = RadDragAndDropManager.GenerateArrowCue();



				// You can assign the image or anything else you like as a drag cue.
				// The generate merhod on the DragDropManager just creates an empty content cotnrol for you
				// based on the size of the object that is passed.
				// I have used the TreeViewDragCue so that I would not have to create it myself
				var dragCue = new TreeViewDragCue();
				dragCue.ItemsSource = items;
				dragCue.ItemTemplate = this.Resources["EmployeeTemplate"] as DataTemplate;

				e.Options.DragCue = dragCue;
			}

			if (e.Options.Status == DragStatus.DropSourceQuery)
			{
				e.QueryResult = true;
				e.Handled = true;
			}
		}

		private void LoadEmployee()
		{

			Employee emp1 = new Employee();
			emp1.id = tempid;
			emp1.Name = "miral";
			emp1.Company = "K9";

			Employee emp2 = new Employee();
			emp2.id = 2;
			emp2.Name = "Piyush";
			emp2.Company = "K9";

			Employee emp3 = new Employee();
			emp3.id = 3;
			emp3.Name = "Chirag";
			emp3.Company = "K9";

			_employee.Add(emp1);
			_employee.Add(emp2);
			_employee.Add(emp3);

		}

		private void LoadTreeFolders()
		{
			TreeViewFolder parentFolder = new TreeViewFolder();
			parentFolder.Id = 1;
			parentFolder.Name = "Personal Folder";
			parentFolder.CanCotnainEmployees = true;


			TreeViewFolder child1 = new TreeViewFolder();
			child1.Id = 2;
			child1.Name = "Inbox";
			// Each parent needs to have its chidlren added:
			parentFolder.Children.Add(child1);
			child1.CanCotnainEmployees = true;

			TreeViewFolder child2 = new TreeViewFolder();
			child2.Id = 3;
			child2.Name = "Outbox";
			parentFolder.Children.Add(child2);

			TreeViewFolder child3 = new TreeViewFolder();
			child3.Id = 4;
			child3.Name = "SentItems";
			parentFolder.Children.Add(child3);

			TreeViewFolder child4 = new TreeViewFolder();
			child4.Id = 5;
			child4.Name = "DeletedItems";
			parentFolder.Children.Add(child4);

			// There is no need to create TreeViewItems manually
			// an itemsSource can be assigned, just as with the GridView:

			folders.Add(parentFolder);

			this.Tree.ItemsSource = folders;

		}

		private void OnSelect(object sender, RoutedEventArgs e)
		{
			// We use the ids of the folder items to select an item:
			var treeItem = Tree.GetItemByPath("1|3", "|");
			treeItem.IsSelected = true;
		}






	}
}
